#set UnusedPin
set_property BITSTREAM.CONFIG.UNUSEDPIN Pullnone [current_design]

#system slock
set_property PACKAGE_PIN Y18 [get_ports clk50m]
set_property IOSTANDARD LVCMOS33 [get_ports clk50m]

#reset active low,S4
set_property PACKAGE_PIN B21 [get_ports reset_n]
set_property IOSTANDARD LVCMOS33 [get_ports reset_n]

#led
set_property PACKAGE_PIN M22 [get_ports {led[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {led[0]}]
set_property PACKAGE_PIN N22 [get_ports {led[1]}]
set_property IOSTANDARD LVCMOS33 [get_ports {led[1]}]
set_property PACKAGE_PIN L21 [get_ports {led[2]}]
set_property IOSTANDARD LVCMOS33 [get_ports {led[2]}]
set_property PACKAGE_PIN K21 [get_ports {led[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {led[3]}]

#ͷ1 չӿGPIO0
set_property PACKAGE_PIN A14 [get_ports camera1_rst_n]
set_property IOSTANDARD LVCMOS33 [get_ports camera1_rst_n]
set_property PACKAGE_PIN A15 [get_ports {camera1_data[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera1_data[0]}]
set_property PACKAGE_PIN A16 [get_ports {camera1_data[1]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera1_data[1]}]
set_property PACKAGE_PIN A18 [get_ports {camera1_data[2]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera1_data[2]}]
set_property PACKAGE_PIN A19 [get_ports {camera1_data[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera1_data[3]}]
set_property PACKAGE_PIN F13 [get_ports {camera1_data[4]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera1_data[4]}]
set_property PACKAGE_PIN F14 [get_ports {camera1_data[5]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera1_data[5]}]
set_property PACKAGE_PIN E13 [get_ports {camera1_data[6]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera1_data[6]}]
set_property PACKAGE_PIN E14 [get_ports {camera1_data[7]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera1_data[7]}]
set_property PACKAGE_PIN C13 [get_ports camera1_xclk]
set_property IOSTANDARD LVCMOS33 [get_ports camera1_xclk]
set_property PACKAGE_PIN B13 [get_ports camera1_pclk]
set_property IOSTANDARD LVCMOS33 [get_ports camera1_pclk]
set_property PACKAGE_PIN D14 [get_ports camera1_href]
set_property IOSTANDARD LVCMOS33 [get_ports camera1_href]
set_property PACKAGE_PIN D15 [get_ports camera1_vsync]
set_property IOSTANDARD LVCMOS33 [get_ports camera1_vsync]
set_property PACKAGE_PIN C14 [get_ports camera1_sdat]
set_property IOSTANDARD LVCMOS33 [get_ports camera1_sdat]
set_property PULLUP true [get_ports camera1_sdat]
set_property PACKAGE_PIN C15 [get_ports camera1_sclk]
set_property IOSTANDARD LVCMOS33 [get_ports camera1_sclk]
set_property PULLUP true [get_ports camera1_sclk]

set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets camera1_pclk_IBUF]

#ͷ2 չӿGPIO0
set_property PACKAGE_PIN B16 [get_ports camera2_rst_n]
set_property IOSTANDARD LVCMOS33 [get_ports camera2_rst_n]
set_property PACKAGE_PIN D17 [get_ports {camera2_data[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera2_data[0]}]
set_property PACKAGE_PIN C17 [get_ports {camera2_data[1]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera2_data[1]}]
set_property PACKAGE_PIN D16 [get_ports {camera2_data[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera2_data[2]}]
set_property PACKAGE_PIN E16 [get_ports {camera2_data[2]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera2_data[3]}]
set_property PACKAGE_PIN B17 [get_ports {camera2_data[4]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera2_data[4]}]
set_property PACKAGE_PIN B18 [get_ports {camera2_data[5]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera2_data[5]}]
set_property PACKAGE_PIN C18 [get_ports {camera2_data[6]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera2_data[6]}]
set_property PACKAGE_PIN C19 [get_ports {camera2_data[7]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera2_data[7]}]
set_property PACKAGE_PIN F16 [get_ports camera2_xclk]
set_property IOSTANDARD LVCMOS33 [get_ports camera2_xclk]
set_property PACKAGE_PIN E17 [get_ports camera2_pclk]
set_property IOSTANDARD LVCMOS33 [get_ports camera2_pclk]
set_property PACKAGE_PIN D20 [get_ports camera2_href]
set_property IOSTANDARD LVCMOS33 [get_ports camera2_href]
set_property PACKAGE_PIN C20 [get_ports camera2_vsync]
set_property IOSTANDARD LVCMOS33 [get_ports camera2_vsync]
set_property PACKAGE_PIN E19 [get_ports camera2_sdat]
set_property IOSTANDARD LVCMOS33 [get_ports camera2_sdat]
set_property PULLUP true [get_ports camera2_sdat]
set_property PACKAGE_PIN D19 [get_ports camera2_sclk]
set_property IOSTANDARD LVCMOS33 [get_ports camera2_sclk]
set_property PULLUP true [get_ports camera2_sclk]

set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets camera2_pclk_IBUF]

#5/4.3TFTģ飨ʹչGPIO2
set_property PACKAGE_PIN R17 [get_ports TFT_clk]
set_property IOSTANDARD LVCMOS33 [get_ports TFT_clk]
set_property PACKAGE_PIN N17 [get_ports TFT_de]
set_property IOSTANDARD LVCMOS33 [get_ports TFT_de]
set_property PACKAGE_PIN R18 [get_ports TFT_pwm]
set_property IOSTANDARD LVCMOS33 [get_ports TFT_pwm]
set_property PACKAGE_PIN T18 [get_ports TFT_hs]
set_property IOSTANDARD LVCMOS33 [get_ports TFT_hs]
set_property PACKAGE_PIN U18 [get_ports TFT_vs]
set_property IOSTANDARD LVCMOS33 [get_ports TFT_vs]
set_property PACKAGE_PIN J5 [get_ports {TFT_rgb[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[0]}]
set_property PACKAGE_PIN K6 [get_ports {TFT_rgb[1]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[1]}]
set_property PACKAGE_PIN R16 [get_ports {TFT_rgb[2]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[2]}]
set_property PACKAGE_PIN R14 [get_ports {TFT_rgb[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[3]}]
set_property PACKAGE_PIN P17 [get_ports {TFT_rgb[4]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[4]}]
set_property PACKAGE_PIN P6 [get_ports {TFT_rgb[5]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[5]}]
set_property PACKAGE_PIN N4 [get_ports {TFT_rgb[6]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[6]}]
set_property PACKAGE_PIN M6 [get_ports {TFT_rgb[7]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[7]}]
set_property PACKAGE_PIN N5 [get_ports {TFT_rgb[8]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[8]}]
set_property PACKAGE_PIN L6 [get_ports {TFT_rgb[9]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[9]}]
set_property PACKAGE_PIN M5 [get_ports {TFT_rgb[10]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[10]}]
set_property PACKAGE_PIN R1 [get_ports {TFT_rgb[11]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[11]}]
set_property PACKAGE_PIN P2 [get_ports {TFT_rgb[12]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[12]}]
set_property PACKAGE_PIN N3 [get_ports {TFT_rgb[13]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[13]}]
set_property PACKAGE_PIN P4 [get_ports {TFT_rgb[14]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[14]}]
set_property PACKAGE_PIN P5 [get_ports {TFT_rgb[15]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[15]}]